package com.example.tdl.web;

import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.AddAlarmLogVo;
import com.example.tdl.entity.AlarmLog;
import com.example.tdl.service.AlarmLogService;
import com.example.tdl.service.GatewayService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@RestController
@RequestMapping("/alarmLog")
public class AlarmLogController {
    private Logger logger= LoggerFactory.getLogger(AlarmLogController.class);

    Gson gson= new Gson();

    CommFeedback fb=new CommFeedback();

    @Autowired
    private AlarmLogService alarmLogServcie;

    @Autowired
    private GatewayService gatewayService;

    //新增报警消息
    @RequestMapping(value = "/addAlarmLog",method = RequestMethod.POST)
    public String addAlarmLog(@RequestBody AddAlarmLogVo addAlarmLogVo){
        if(StringUtils.isEmpty(addAlarmLogVo.getgSN())){
            fb.setCode(0);
            fb.setMessage("网关序列号不能为空");
        }
        if(StringUtils.isEmpty(addAlarmLogVo.getgType())){
            fb.setCode(0);
            fb.setMessage("网关类型不能为空");
        }
        if(addAlarmLogVo.getAlarm()==null){
            fb.setCode(0);
            fb.setMessage("报警数据不能为空");
        }
        if(addAlarmLogVo.getTs() == null){
            fb.setCode(0);
            fb.setMessage("时间不能为空");
        }
        //根据gateway的信息获取线路信息
       String transportationNo =  gatewayService.getTransportationNo(addAlarmLogVo.getgSN(),addAlarmLogVo.getgType());
        for(int i = 0;i<addAlarmLogVo.getAlarm().size();i++){
//            String classify="";
//            if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("温度")){
//                 classify = "1";
//            } else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("湿度")){
//                 classify = "2";
//            } else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("震动")){
//                 classify = "3";
//            } else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("倾角")){
//                 classify = "4";
//            }
////          else  if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("光爆")){
////                 classify = "5";
////            }
//            else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("离线")){
//                 classify = "6";
//            }
//            AlarmLog alarmLog = new AlarmLog(transportationNo,addAlarmLogVo.getAlarm().get(i).getTDLSN(),addAlarmLogVo.getAlarm().get(i).getDesp(),addAlarmLogVo.getAlarm().get(i).getValue(),addAlarmLogVo.getAlarm().get(i).getTs()*1000,classify);
            AlarmLog alarmLog = new AlarmLog(transportationNo,addAlarmLogVo.getAlarm().get(i).getTDLSN(),"温度异常",addAlarmLogVo.getAlarm().get(i).getValue(),addAlarmLogVo.getAlarm().get(i).getTs()*1000,"1");
            int a = alarmLogServcie.addAlarmLog(alarmLog);
            if(a == 0){
                fb.setCode(0);
                fb.setMessage("添加失败");
            }else{
                fb.setCode(1);
                fb.setMessage("添加成功");
            }
        }
        return gson.toJson(fb);
    }
}
